import Backup.Archive
import Backup.Config
import Backup.Directories
import Data.Map
import System.Posix.Types
import System.Environment


main = do
    args <- getArgs
    config <- openConfig
    let dirs = baseDirs config 
    let destPath = destinationPath config
    --if (any (== "full") args)
    if False
    then
        fullBackup dirs destPath
    else
        diffBackup dirs destPath
    putStrLn "Done :]"


fullBackup :: [FilePath] -> FilePath -> IO ()
fullBackup files tarPath = do
    items <- getAllItems files
    let numItems = sum [length (dirs i) | i <- items]
    entries <- backupDirsToEntries items
    putStrLn $ (show numItems) ++ " files to back up"
    tarName <- fullPath 
    let fullTar = tarPath ++ tarName
    createBackupArchive fullTar entries
    mtimes <- getAllMtimes items
    writeMap (buildMap mtimes)


diffBackup :: [FilePath] -> FilePath -> IO ()
diffBackup files tarPath = do
    items <- getAllItems files
    mtimes <- getAllMtimes items
    let current = buildMap mtimes
    records <- readMap
    let updated = toBackup records current
    putStrLn $ (show (length updated)) ++ " files to back up"
    entries <- fileMetadataToEntries updated
    tarName <- diffPath
    let fullTar = tarPath ++ tarName
    createBackupArchive fullTar entries

